
#include <ctype.h>
#include<stdio.h>
#include <stdlib.h>
#include <string.h>

char line[1048576];

int number_of_sequences_in_fasta_file(FILE * file){
	int sequences_number=0;
	int previous_is_a_comment=0;
	rewind(file);
	do{
		if(fgets(line,1048575,file) == NULL) break;
		if(line[0]=='>'){
			if(!previous_is_a_comment){
				previous_is_a_comment=1;
				sequences_number++;
			}
		}
		else previous_is_a_comment=0;
	}
	while(1);
	rewind(file);
	return sequences_number;
}

int next(FILE * file){
  if(fgets(line,1048575,file) == NULL) return 0; // read comment
  if(fgets(line,1048575,file) == NULL) return 0; // read read
  return 1;
}

int get_next_sequence_and_comments (FILE * file, char * sequence, char * comment){
	char *rv;
	char *p;
	int nextchar=0;
	rv=fgets((char *)comment,1048576,file);// read comment ('>read00xxxx...\n')

	if(rv == NULL) return 0;
	do{
		rv=fgets((char *)sequence,1048575,file); //
	}while(sequence[0]=='>');


	p = (char *)strchr((char*)sequence, '\n');
	if (p) *p = '\0';
	p = (char *)strchr((char*)sequence, '\r');
	if (p) *p = '\0';

	nextchar=fgetc(file); // cheat, reads the next '>' character in order to induce EOF

	while (nextchar!='>' && !feof(file))
	{
		fseek(file, -1, SEEK_CUR);
		rv=fgets((char *)line,1048576,file);// read comment ('>read00xxxx...\n')
		rv = strchr(line, '\n'); // find the last \n char
		if(rv) *rv = '\0';       // change it into \0
		rv = strchr(line, '\r'); // find the last \r char
		if(rv) *rv = '\0';       // change it into \0

		strcat(sequence, line); // concat the restult in the sequence

		nextchar=fgetc(file); // cheat, reads the next '>' character in order to induce EOF
	}
	return strlen(sequence); // readlen
}

int get_next_sequence (FILE * file, char * sequence){
	char *rv;
	char *p;
	int nextchar=0;
	rv=fgets((char *)line,1048576,file);// read comment ('>read00xxxx...\n')
	if(rv == NULL) return 0;
	do{
		rv=fgets((char *)sequence,1048575,file); //
	}while(sequence[0]=='>');


	p = (char *)strchr((char*)sequence, '\n');
	if (p) *p = '\0';
	p = (char *)strchr((char*)sequence, '\r');
	if (p) *p = '\0';

	nextchar=fgetc(file); // cheat, reads the next '>' character in order to induce EOF

	while (nextchar!='>' && !feof(file))
	{
		fseek(file, -1, SEEK_CUR);
		rv=fgets((char *)line,1048576,file);// read comment ('>read00xxxx...\n')
		rv = strchr(line, '\n'); // find the last \n char
		if(rv) *rv = '\0';       // change it into \0
		rv = strchr(line, '\r'); // find the last \r char
		if(rv) *rv = '\0';       // change it into \0

		strcat(sequence, line); // concat the restult in the sequence

		nextchar=fgetc(file); // cheat, reads the next '>' character in order to induce EOF
	}
	//printf("return sequence %s\n",sequence);
	return strlen(sequence); // readlen
}


int main (int argc, char **argv){
  printf("%d \n",argc);
  if(argc!=3 && argc!=4){
    fprintf(stderr,"usage: %s file_name number_of_reads_to extract [total_number_of_reads]\n", argv[0]);
    fprintf(stderr,"Randomly extract number_of_reads_to_extract from file_name\n");
    fprintf(stderr,"if the totla number of reads is provided, this number is not recomputed (looooong computation)\n");
    exit(1);
  }
  unsigned long cpt=0;
  char *buffer =(char*)malloc(10000);
  srand(time(NULL));
  int number_of_reads=atoi(argv[2]);
  char * read = (char *) malloc(10000);
  char * comment = (char *) malloc(10000);
  FILE * read_file = fopen(argv[1], "r");
  if(read_file==NULL){
    fprintf(stderr,"cannot open %s for reading, exit\n", argv[1]);
    exit(1);
  }

  if(argc==3){
    fprintf(stderr, "computing number of reads...");
    cpt= number_of_sequences_in_fasta_file(read_file);
    fprintf(stderr, " ...done\n%s contains %d reads. We extract %d among them \n", argv[1], (int)cpt, number_of_reads);
    
  }

  if(argc==4){
    cpt=atoi(argv[3]);
     fprintf(stderr, " We consider %s contains %d reads.  We extract %d among them \n", argv[1], (int)cpt, number_of_reads);
  }

  /* while(fgets(buffer,10000,read_file)) { */
  /*   if(buffer[0]=='>') cpt++; */
  /* } */

  
    fclose(read_file);
   
  if(number_of_reads<1) exit(0);
  int found = 0;
  read_file = fopen(argv[1], "r");
  while(found<number_of_reads){
    rewind(read_file);
    while(next(read_file) && found<number_of_reads){
      int nombre = 1 + (int)(rand()/(float)RAND_MAX * (cpt/number_of_reads));
      if(nombre==1){
	get_next_sequence_and_comments(read_file,read, comment);
	found++;
	printf(">%s%s\n", comment, read);
      }
    }
  }
  fclose(read_file);
  return 0;
}
